﻿vatModule.controller('ImportDataCtrl', ['$scope', '$log', 'Upload', '$timeout', '$http', '$cookies', '$translate', '$interval', 'enums'
    , 'SweetAlert', 'dataImportService', 'vatImportService', 'modelConfigurationService'
    , 'vatSessionService', 'uiGridConstants', 'projectService', 'vatCommonService', 'vatOperationLogService', 'vatWorkflowService',
function ($scope, $log, Upload, $timeout, $http, $cookies, $translate, $interval, enums
    , SweetAlert, dataImportService, vatImportService, modelConfigurationService
    , vatSessionService, uiGridConstants, projectService, vatCommonService, vatOperationLogService, vatWorkflowService) {
    var apiTokenObj = $cookies.getObject('AtmsApiToken');
    var webHost = apiTokenObj.api_host;
    var fileGuid = ''; //保存上传文件后在server端生成的guid 
    var importMethod = ''; //oneClick:一键导入；universal：万能导入
    var importType = -1; //0:覆盖；1：添加
    var projectId = vatSessionService.project.id;
    var period = vatSessionService.month; //period < 0 覆盖导入时会删除所有数据
    var projectDbName = vatSessionService.project.dbName;
    var fileExtension = '';
    var fileNames = [];
    var token = $('input[name="__RequestVerificationToken"]').val();
    var CONST_ACEOLEDB = "Microsoft.ACE.OLEDB.12.0 is not registered"; 
    //上传文件有效后缀名
    var ValidFileExtension = {
        CSV: "csv",
        XLS: "xls",
        XLSX: "xlsx"
    }
    //对应PwC.Tax.Tech.Atms.Globals.Utils:ErpCheckType
    var ErpCheckTypeEnum = {
        Success : 0,
        ComBalanceAcctUnValidate : 1, 
        VoucherAcctValidate : 2, 
        VSingleDebitCreditUnValidate : 3,
        VEmptyCheckUnValidateItemID : 4,
        VEmptyCheckUnValidateGroup : 5,
        VEmptyCheckUnValidateAcctCode : 6,
        VEmptyCheckUnValidateSummary : 7,
        AcctBegBalAcctLevelUnValidate : 8,
        BegBalUnValidate : 9, 
        CompCustEndBalUnValidate : 10,
        CompCustAmountUnValidate : 11,
        CompCustBegBalUnValidate : 12,
        BegEndBalUnValidate : 13,
        DuplicatedVoucher: 14,
        DuplicatedTb: 15
    }
    var TbImportTypeEnum = {
        UnImported : 0,
        TbImported : 1,
        ErpImported : 2
    }

    var validteCategoryEnum = {
        Basic: 1,
        Correctness: 2,
        Duplicate:3
    }

    $scope.period = period;
    $scope.filePath = '';
    $scope.showUniversal = false;
    $scope.startNumber = -1;
    $scope.excelDownloadPath = webHost + '/Resource/ImportData/万能模板.xls';
    $scope.csvDownLoadPath = webHost + '/Resource/ImportData/csv万能模板.zip';
    $scope.duplicateList = [];
    $scope.basicCheckList = [];
    $scope.correctCheckList = [];
    var validteCategory = validteCategoryEnum.Basic;
    //写日志
    var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
    $scope.moduleid = enums.vatModuleEnum.Import_Erpdata;
    var logDto = {
        ID: '',
        OperationName: '',
        ModuleID: $scope.moduleid,
        OperationObject: $translate.instant('erpData'),
        OperationType: '',
        OperationContent: '',
        OriginalState: '',
        UpdateState: '',
        CreatorID: vatSessionService.logUser.ID,
        Comment: comment,
        IP: '',
        Period: $scope.period,
    };

    //设置正确性、重复数据验证的错误提示图标
    $scope.setValidationErrorStyle = function (chkCorrect,checkDuplicate) {       
        var errorCount = 0;
        var duplicateNum = 0;
        var activeErrorStyle = {
            'background-image': 'url(/app-resources/images/vat/error.png)',
            'background-repeat': 'no-repeat',
            'background-position': 'right 5px center'
        }

        var inactiveErrorStyle = {
            'background-image': 'none'
        }

        if (chkCorrect) {
            for (var i = 1; i < $scope.correctCheckList.length; i++) {
                errorCount = $scope.correctCheckList[i][3]; //[3]: errorCount
                if (errorCount > 0) {
                    break;
                }
            }

            if (errorCount > 0) {
                return activeErrorStyle;
            }
            else {
                return inactiveErrorStyle;
            }
        }
        

        if (checkDuplicate) {
            for (var i = 1; i < $scope.duplicateList.length; i++) {
                duplicateNum = $scope.duplicateList[i][2]; //[2]: duplicateCount;
                if (duplicateNum > 0) {
                    break;
                }
            }

            if (duplicateNum > 0) {
                return activeErrorStyle;
            }
            else {
                return inactiveErrorStyle;
            }
        }
                                    
    };


    //点击一键/万能导入
    $scope.switch = function (index) {
        //一键导入
        if (index === 1) {
            $scope.filePath = $translate.instant('ConfirmSelectErpImportFileTitle');
            importMethod = 'oneClick';
            $scope.showUniversal = false;
            $scope.startNumber = -1;
            $('#btnOneClick').removeClass('disableBtn');
            $('#btnUniversal').addClass('disableBtn');
        }

        //万能导入
        if (index === 2) {
            $scope.filePath = $translate.instant('ConfirmSelectErpImportFileTitle');
            importMethod = 'universal';
            $scope.showUniversal = true;
            $scope.startNumber = 0;
            $('#btnUniversal').removeClass('disableBtn');
            $('#btnOneClick').addClass('disableBtn');
        }
    }


    //上传文件
    $scope.uploadFiles = function (files, errFiles) {
        $scope.f = files;
        $scope.showError = false;
        $scope.errFile = errFiles && errFiles[0];
        if (files && files.length) {
            fileNames = [];
            angular.forEach($scope.f, function (file) {
                fileNames.push(file.name);
            })
            $scope.filePath = fileNames.toString();//$scope.f[0].name;
            if (!checkUploadFiles($scope.f)) {
                return false;
            }

            Upload.upload({
                url: webHost + '/api/v1/financeImportData/importData/financeDataUpload',
                data: {
                    importMethod: importMethod,
                    file: files
                },
                headers: {
                    'Access-Control-Allow-Origin': '*',
                     Authorization: apiTokenObj.token_type + ' ' + apiTokenObj.access_token,
                     from: vatSessionService.project.id
                },
                __RequestVerificationToken: token,
                withCredentials: true
            }).then(function (response) {
                var ret = response.data;
                if (ret.result) {
                    fileGuid = ret.data.guid;
                    fileExtension = ret.data.fileExtension;                 
                    //swal({
                    //    title: $translate.instant('SuccessTitle'),
                    //    text: $translate.instant('UploadFileSuccess'),
                    //    type: "success",
                    //    confirmButtonText: $translate.instant('Confirm')
                    //});
                }
                else {
                    if (ret.resultMsg && ret.resultMsg.length > 0) {
                        swal({
                            title:$translate.instant('FailureTitle'),
                            text: $translate.instant('UploadFileFail') + ret.resultMsg,
                            type: "error",
                            confirmButtonText: $translate.instant('Confirm')
                        });
                        //alert(ret.resultMsg);
                    }
                }

                //$timeout(function () {
                //    file.result = response.data;
                //});

            }, function (response) {
                console.log('import error: ' + response.status);
                if (response.status > 0) {
                    //$scope.errorMsg = response.status + ': ' + response.data;
                    $log.debug('erp load file error:');
                    $log.debug(response.status + ': ' + response.data);
                }
                    

            }, function (evt) {
                //file.progress = Math.min(100, parseInt(100.0 *
                //                         evt.loaded / evt.total));
                $scope.progress =
                  Math.min(100, parseInt(100.0 * evt.loaded / evt.total));

            });
        }
        else {
            // $scope.showError = true;
        }

    }


    //导入财务数据
    $scope.importData = function (importTypeParam) {
        if ($scope.filePath == $translate.instant('ConfirmSelectErpImportFileTitle'))
        {
            swal({
                title: $translate.instant('ConfirmSelectErpImportFileTitle'),
                text: $translate.instant('ConfirmSelectErpImportFile'),
                type: "warning",
                confirmButtonText: $translate.instant('Yes')   
            });
            return false;
        }

        if (vatSessionService.project.projectStatusList[period] >= constant.ProjectStatusEnum.Imported) {
            swal({
                title: "warning!",
                text: $translate.instant('IsConfirmToReImport').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[period]) }),
                type: "warning",
                showCancelButton: true,
                confirmButtonText: $translate.instant('ConfirmYes'),
                cancelButtonText: $translate.instant('ConfirmNo'),
                closeOnConfirm: false,
                closeOnCancel: false
            },
            function (isConfirm) {
                if (isConfirm) {
                    swal.close();
                    startToImportErpData(importTypeParam);
                }
                else {               
                    swal.close();
                }
            });  
        }
        else {
            startToImportErpData(importTypeParam);
        }
            
            
        
    }


    //日志
    $scope.showOperateLogPop = function () {
        $scope.isShowLog = true;
    };


    function startToImportErpData(importTypeParam) {
        var importFileName = "";
        $scope.f.forEach(function (item, index) {
            importFileName += item.name;
        });
        logDto.ID = PWC.newGuid();
        logDto.CreateTime = new Date();
        logDto.UpdateTime = new Date();
        logDto.OperationContent = importFileName;
        if (importTypeParam === 0) { 
            logDto.OperationName = $translate.instant('ConvertErpData');
            logDto.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
        }
        else if (importTypeParam === 1) {
            logDto.OperationName = $translate.instant('AppendErpData');
            logDto.OperationType = enums.vatLogOperationTypeEnum.AddImport;
        }
       
        vatImportService.getImportType(projectId, period).success(function (data) {
            if (data === TbImportTypeEnum.UnImported || data === TbImportTypeEnum.ErpImported) {
                importErpData(importTypeParam);
            }

            if (data === TbImportTypeEnum.TbImported) {
                swal({
                    title: $translate.instant('ConfirmCleartTbTitle'),
                    text: $translate.instant('ConfirmTbDataToDelete'),
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonText: $translate.instant('Yes'),
                    cancelButtonText: $translate.instant('No'),
                    closeOnConfirm: true,
                    closeOnCancel: true
                },
                 function (isConfirm) {
                     //1. 清除TB导入数据
                     if (isConfirm) {
                         $log.debug("confirm to clear TB data");
                         vatImportService.deleteTbData(period)
                           .success(function (data) {
                               $log.debug("deleteTbData(period): ", data);
                               //2. 导入财务数据
                               if (data) {                                 
                                   importErpData(importTypeParam);
                               }
                               else {
                                   swal({
                                       title: $translate.instant('FailureTitle'),
                                       text: $translate.instant('ClearTbError'),
                                       type: "error",
                                       confirmButtonText: $translate.instant('Confirm')
                                   });
                               }
                           });
                     }
                 });
            }
        });
    }

    //校验界面
    $scope.openTab = function (evt, tabId) {
        var i, tabcontent, tablinks;
        //隐藏所有tabContent
        tabcontent = document.getElementsByClassName("tabContent");
        for (i = 0; i < tabcontent.length; i++) {
            tabcontent[i].style.display = "none";
        }

        //删除所有tab button中的active, inactive class
        tablinks = document.getElementsByClassName("tablinks");
        for (i = 0; i < tablinks.length; i++) {
            tablinks[i].className = tablinks[i].className.replace(" active", "");
            tablinks[i].className = tablinks[i].className.replace(" inactive", "");
            tablinks[i].className = tablinks[i].className.replace(" inactive-rightborder", "");   
        }

        //设置选中tab   
        document.getElementById(tabId).style.display = "block";
        evt.currentTarget.className += " active";

        //设置未选中tab
        for (i = 0; i < tablinks.length; i++) {
            if (tablinks[i].id != evt.currentTarget.id) {
                tablinks[i].className += " inactive";

                if ($("#btnCorrectChk").attr("class").indexOf(" active") === -1) {
                    if (_.isEqual(tablinks[i].id, "btnBasicChk")) {
                        tablinks[i].className += " inactive-rightborder";
                    }

                    if (_.isEqual(tablinks[i].id, "btnCorrectChk")) {
                        //基础数据验证和数据正确性验证都不可用时，只要基础数据验证加右边框就可以了
                        if ($("#btnBasicChk").attr("class").indexOf("inactive-rightborder") === -1) {
                            tablinks[i].className += " inactive-rightborder";
                        }
                    }
                }
                
            }            
        }

        //clearAllDataValidationArray();
        if (evt.currentTarget.id === "btnDuplicateData") {
            validteCategory = validteCategoryEnum.Duplicate;
            if ($scope.duplicateList.length === 0) {
                getDuplicateRecords();
            }
            
        }

        if (evt.currentTarget.id === "btnBasicChk") {
            validteCategory = validteCategoryEnum.Basic;
           if ($scope.basicCheckList.length === 0) {
                getBasicValidationRecords();
           }
            
        }

        if (evt.currentTarget.id === "btnCorrectChk") {
            validteCategory = validteCategoryEnum.Correctness;
           if ($scope.correctCheckList.length === 0) {
               getCorrectValidationRecords();
           }
        }
    }


    //双击查看验证详细数据
    $scope.checkDetailDbclick = function (evt) {
        //对应enum： ErpCheckType
        var erpCheckTypeId = -1;
        var errorCount = -1;
        if ($scope.basicCheckList.length > 0 && _.isEqual(validteCategory,validteCategoryEnum.Basic)) {          
            erpCheckTypeId = $scope.basicCheckList[evt.currentTarget.rowIndex][5];
            errorCount = $scope.basicCheckList[evt.currentTarget.rowIndex][3];
        }

        if ($scope.correctCheckList.length > 0 && _.isEqual(validteCategory,validteCategoryEnum.Correctness)) {
            erpCheckTypeId = $scope.correctCheckList[evt.currentTarget.rowIndex][5];
            errorCount = $scope.correctCheckList[evt.currentTarget.rowIndex][3];
        }
        
        if ($scope.duplicateList.length > 0 && _.isEqual(validteCategory,validteCategoryEnum.Duplicate)) {
            erpCheckTypeId = $scope.duplicateList[evt.currentTarget.rowIndex][3];
            errorCount = $scope.duplicateList[evt.currentTarget.rowIndex][2]; 
        }

        if (errorCount > 0) {
            getCheckDetails(erpCheckTypeId);
            if (erpCheckTypeId === ErpCheckTypeEnum.DuplicatedVoucher) {
                $('#duplicatedVouchers').modal('show');
            }
            else if (erpCheckTypeId === ErpCheckTypeEnum.DuplicatedTb) {
                $('#duplicatedTbes').modal('show');
            }
            else {
                $('#detailListModal').modal('show');
            }                  
        }
        else {
            swal({
                title: $translate.instant('WarningTitle'),
                text: $translate.instant('ErpDetailWarning'),
                type: "warning",
                confirmButtonText: $translate.instant('Confirm')
            });
        }     
    }


    //删除选中的Voucher
    $scope.deleteDuplicateVouchers = function () {
        var selectedVouchers = $scope.gridApi.selection.getSelectedGridRows();
        $log.debug("get selected duplicated voucher details");
        $log.debug(selectedVouchers);
     
        if (selectedVouchers.length > 0) {
            var voucherIds = [];
            var voucherAccts = [];
            selectedVouchers.forEach(function(item,index){
                if (!_.isNull(item.entity.voucherID)) {
                    voucherIds.push(item.entity.voucherID);
                    voucherAccts.push(item.entity.acctCode);
                }
            });

            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = voucherAccts.join(",");
            logDto.OperationName = $translate.instant('DeleteVoucherDuplicate');
            logDto.OperationType = enums.vatLogOperationTypeEnum.DeleteDuplicate;

            $log.debug("voucherIds ready to be deleted: " + voucherIds);
            //delete 
            dataImportService.deleteVoucherDuplicateItems(voucherIds)
              .success(function (data) {
                  $log.debug("delete duplicated vouchers results: " + data);
                  $('#duplicatedVouchers').modal('hide');
                  if (data) {
                      swal({
                          title: $translate.instant('SuccessTitle'),
                          text: $translate.instant('DeleteSuccess'),
                          type: "success",
                          timer: 1000
                      });

                      logDto.UpdateState = $translate.instant('DeleteSuccess');
                      vatOperationLogService.addOperationLog(logDto);
                      ReCheckAndManageData();
                  }        
                 
              });
        }
        else {
            logDto.UpdateState = $translate.instant('DeleteFailed');
            vatOperationLogService.addOperationLog(logDto);

            swal({
                title: $translate.instant('WarningTitle'),
                text: $translate.instant('DeleteEmptyWarning'),
                type: "warning",
                confirmButtonText: $translate.instant('Confirm')
            });
        }
    }


    //删除选中的CustBalance
    $scope.deleteDuplicateTbes = function () {
        var selectedTbes = $scope.gridApiTb.selection.getSelectedGridRows();
        $log.debug("get selected duplicated custbalance details");
        $log.debug(selectedTbes);
        if (selectedTbes.length > 0) {
            var balanceIds = [];
            var balanceAccts = [];
            selectedTbes.forEach(function (item, index) {
                if (!_.isNull(item.entity.balanceId)) {
                    balanceIds.push(item.entity.balanceId);
                    balanceAccts.push(item.entity.acctCode);
                }
            });

            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = balanceAccts.join(",");
            logDto.OperationName = $translate.instant('DeleteCustBalanceDuplicate');
            logDto.OperationType = enums.vatLogOperationTypeEnum.DeleteDuplicate;

            $log.debug("balanceIds ready to be deleted: " + balanceIds);
            //delete 
            dataImportService.deleteCustBalanceItems(balanceIds)
              .success(function (data) {
                  $log.debug("delete duplicated custbalance results: " + data);
                  $('#duplicatedTbes').modal('hide');
                  if (data) {
                      swal({
                          title: $translate.instant('SuccessTitle'),
                          text: $translate.instant('DeleteSuccess'),
                          type: "success",
                          timer: 1000
                      });
                      logDto.UpdateState = $translate.instant('DeleteSuccess');
                      vatOperationLogService.addOperationLog(logDto);
                      ReCheckAndManageData();
                  }
              });
        }
        else {
            logDto.UpdateState = $translate.instant('DeleteFailed');
            vatOperationLogService.addOperationLog(logDto);

            swal({
                title: $translate.instant('WarningTitle'),
                text: $translate.instant('DeleteEmptyWarning'),
                type: "warning",
                confirmButtonText: $translate.instant('Confirm')
            });
        }
    }
    
    
    //检查用户机构权限
    $scope.checkUserOrganizationPermissionList = function () {
        var list = [];
        var userManageTemp = constant.vatPermission.dataImport.erpImport;
        list.push(userManageTemp.importCode);
        $scope.hasImportPermission = false;
        $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {                     
            $scope.hasImportPermission = data[userManageTemp.importCode];        
        });
    };


    //根据hasImportPermission设置按钮的样式
    $scope.setButtonSetByPermission = function () {
        if (!$scope.hasImportPermission) {
            return { cursor: "not-allowed" };
        }
        else {
            return { cursor: "default" };
        }
    };


    //清理数据校验的数组
    function clearAllDataValidationArray() {
        $log.debug("start to clear all data validation array");
        $scope.duplicateList = [];
        $scope.basicCheckList = [];
        $scope.correctCheckList = [];
    }


    //导入数据
    function importErpData(importTypeParam) {
        $log.debug("start to import data");
        importType = importTypeParam;
        $http({
            method: 'POST',
            url: webHost + '/api/v1/financeImportData/importData/importFinancedata',
            params: {
                importMethod: importMethod,
                importType: importType,
                fileName: fileNames,
                fileGuid: fileGuid,
                fileExtension: fileExtension,
                period: period
            },
            headers: {
                'Access-Control-Allow-Origin': '*',
                Authorization: apiTokenObj.token_type + ' ' + apiTokenObj.access_token,
                from: vatSessionService.project.id
            },
            __RequestVerificationToken: token,
            withCredentials: true
        }).then(function successCallback(response) {
            var ret = response.data;
            if (ret.result) {
                swal({
                    title:$translate.instant('SuccessTitle'),
                    text: $translate.instant('ImportErpDataSuccess'),
                    type: "success",
                    timer: 1000           
                });
                $log.debug("import data successfully,start to update project import type");
                logDto.UpdateState = $translate.instant('ImportSuccess');
                vatOperationLogService.addOperationLog(logDto);
                updateProjectImportType();
                clearAllDataValidationArray();                   
                vatCommonService.importSetProjectStatus(projectDbName, period
                                                        , constant.DictionaryDictKey.WFImportErpData
                                                        , enums.FinishStatusEnum.Finished);
                vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isErpImport, true);
                $log.debug("import erp importErpData: " + vatSessionService.project.importSubStatus.isErpImport);
                startManageData(period);               
                $scope.filePath = $translate.instant('ConfirmSelectErpImportFileTitle');; //还原导入文件路径
                $scope.isImportTypeErp = true;
                
            }
            else {
                $scope.filePath = $translate.instant('ConfirmSelectErpImportFileTitle');//还原导入文件路径; //清理导入文件路径
                if (ret.resultMsg && ret.resultMsg.length > 0) {
                    var errorMessages = "";
                    var popUpErrorMsg = "";
                    ret.data.forEach(function (item, index) {
                        errorMessages = errorMessages + "\r\n" + item.errorMsg;
                    });
                    //出错信息中包含CONST_ACEOLEDB的话，弹出特殊提示
                    errorMessages = errorMessages.toLowerCase();
                    if (errorMessages.indexOf(CONST_ACEOLEDB.toLowerCase()) > 0) {
                        popUpErrorMsg = $translate.instant('ACEOLEDBUnInstallError');
                    }
                    else {
                        popUpErrorMsg = $translate.instant('ImportErpDataFail') + ret.resultMsg;
                    }

                    logDto.UpdateState = $translate.instant('FailureTitle');
                    vatOperationLogService.addOperationLog(logDto);

                    swal({
                        title: $translate.instant('FailureTitle'),
                        text: popUpErrorMsg,
                        type: "error",
                        confirmButtonText: $translate.instant('Confirm')
                    });
                }

            }
        }, function errorCallback(response) {
            $log.debug('erp import data error');
            $log.debug(response);
            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
        });
    }


    //上传文件格式验证
    function checkUploadFiles(files) {
        var result = true;
        for (var i = 0; i < files.length; i++) {
            var item = files[i];
            var fileName = item.name;
            var fileExtension = fileName.substr(fileName.lastIndexOf(".") + 1, fileName.length - fileName.lastIndexOf(".")).toLowerCase();
            if (fileExtension !== ValidFileExtension.CSV
              && fileExtension !== ValidFileExtension.XLS
              && fileExtension !== ValidFileExtension.XLSX) {
                swal({
                    title: $translate.instant('WarningTitle'),
                    text:  $translate.instant('ErpUploadFileExtensionCheck'),
                    type:  "warning",
                    confirmButtonText: $translate.instant('Confirm')
                });
                result = false;
            }

            if (fileName.length >= 30) {
                SweetAlert.warning($translate.instant('FileNameTooLong'));
                result = false;
            }
        }
  
        return result;
    }


    //组装重复数据验证数据
    function initDuplicateRecords(or) {
        //添加title
        var data = or.data;
        $scope.duplicateList = [];
        var duplicateTitleDto = [];
        duplicateTitleDto.push($translate.instant('Num'));
        duplicateTitleDto.push($translate.instant('TableName'));
        duplicateTitleDto.push($translate.instant('DuplicateNum'));
        duplicateTitleDto.push($translate.instant('ErpCheckTypeId'));
        $scope.duplicateList.push(duplicateTitleDto);

        data.forEach(function (item, index) {
            var duplicateDto = [];
            if (duplicateTitleDto.indexOf($translate.instant('Num')) !== -1) {
                duplicateDto.push(item.num);
            }

            if (duplicateTitleDto.indexOf($translate.instant('TableName')) !== -1) {
                duplicateDto.push(item.tableName);
            }

            if (duplicateTitleDto.indexOf($translate.instant('DuplicateNum')) !== -1) {
                duplicateDto.push(item.duplicateCount);
            }

            if (duplicateTitleDto.indexOf($translate.instant('ErpCheckTypeId')) !== -1) {
                duplicateDto.push(item.erpCheckTypeId);
            }

            $scope.duplicateList.push(duplicateDto);
        });


        if (or.resultMsg === constant.ValidationMessag.ReValidate) {
            vatWorkflowService.addErpImportExceptionMessage(projectDbName, period, enums.validationType.ErpDuplicate)
                .success(function (or) {
                    if (or.result) {
                        $log.debug("send erp duplicate validation message successfully");
                    }
                });
        }

    }


    //重复数据验证
    function getDuplicateRecords() {
        dataImportService.getDuplicateResults().success(function (or) {
            initDuplicateRecords(or);
          });
    }


    //组装基础校验数据
    function initBasicValicationsRecords(or)
    {
        var data = or.data;
        $scope.basicCheckList = [];
        //添加Title
        var basicChkTilteDto = [];
        basicChkTilteDto.push($translate.instant('Num'));
        basicChkTilteDto.push($translate.instant('ImagePic'));
        basicChkTilteDto.push($translate.instant('DataCheckType'));
        basicChkTilteDto.push($translate.instant('ErrorCount'));
        basicChkTilteDto.push($translate.instant('Tips'));
        basicChkTilteDto.push($translate.instant('ErpCheckTypeId'));
        $scope.basicCheckList.push(basicChkTilteDto);

        data.forEach(function (item, index) {
            var basicChkDto = [];
            if (basicChkTilteDto.indexOf($translate.instant('Num')) !== -1) {
                basicChkDto.push(item.num);
            }


            if (basicChkTilteDto.indexOf($translate.instant('ImagePic')) !== -1) {
                basicChkDto.push(item.imagePic);
            }

            if (basicChkTilteDto.indexOf($translate.instant('DataCheckType')) !== -1) {
                basicChkDto.push(item.dataCheckType);
            }

            if (basicChkTilteDto.indexOf($translate.instant('ErrorCount')) !== -1) {
                basicChkDto.push(item.errorCount);
            }

            if (basicChkTilteDto.indexOf($translate.instant('Tips')) !== -1) {
                basicChkDto.push(item.tips);
            }


            if (basicChkTilteDto.indexOf($translate.instant('ErpCheckTypeId')) !== -1) {
                basicChkDto.push(item.erpCheckTypeId);
            }

            $scope.basicCheckList.push(basicChkDto);
        });

        if (or.resultMsg === constant.ValidationMessag.ReValidate) {
            vatWorkflowService.addErpImportExceptionMessage(projectDbName, period, enums.validationType.ErpBasicCheck)
                .success(function (or) {
                    if (or.result) {
                        $log.debug("send erp basic validation message successfully");
                    }
                });
        }
    }


    //基础数据验证
    function getBasicValidationRecords() {
        dataImportService.getBasicValidationResults()
          .success(function (or) {
              if (or.result) {
                  initBasicValicationsRecords(or);                
              }
              
          });
    }


    //组装数据正确性验证
    function initCorrectValidationRecords(or) {
        //添加Title
        var data = or.data;
        $scope.correctCheckList = [];
        var crtTitleDto = [];
        crtTitleDto.push($translate.instant('Num'));
        crtTitleDto.push($translate.instant('ImagePic'));
        crtTitleDto.push($translate.instant('DataCheckType'));
        crtTitleDto.push($translate.instant('ErrorCount'));
        crtTitleDto.push($translate.instant('Tips'));
        crtTitleDto.push($translate.instant('ErpCheckTypeId'));
        $scope.correctCheckList.push(crtTitleDto);

        data.forEach(function (item, index) {
            var crtValication = [];
            if (crtTitleDto.indexOf($translate.instant('Num')) !== -1) {
                crtValication.push(item.num);
            }

            if (crtTitleDto.indexOf($translate.instant('ImagePic')) !== -1) {
                crtValication.push(item.imagePic);
            }

            if (crtTitleDto.indexOf($translate.instant('DataCheckType')) !== -1) {
                crtValication.push(item.dataCheckType);
            }

            if (crtTitleDto.indexOf($translate.instant('ErrorCount')) !== -1) {
                crtValication.push(item.errorCount);
            }

            if (crtTitleDto.indexOf($translate.instant('Tips')) !== -1) {
                crtValication.push(item.tips);
            }

            if (crtTitleDto.indexOf($translate.instant('ErpCheckTypeId')) !== -1) {
                crtValication.push(item.erpCheckTypeId);
            }
            $scope.correctCheckList.push(crtValication);
        });

        if (or.resultMsg === constant.ValidationMessag.ReValidate) {
            vatWorkflowService.addErpImportExceptionMessage(projectDbName, period, enums.validationType.ErpCorrect)
                .success(function (or) {
                    if (or.result) {
                        $log.debug("send erp correctness validation message successfully");
                    }
                });
        }
    }


    //数据正确性验证
    function getCorrectValidationRecords() {
        dataImportService.getCorrectValidationResults(period).success(function (or) {
              initCorrectValidationRecords(or);
        });
    }


    //运行所有校验并选中基础数据验证
    function getAllValidationResults(isManage) {
        dataImportService.getBasicValidationResults().success(function (or) {
            initBasicValicationsRecords(or);
            dataImportService.getCorrectValidationResults(period).success(function (or) {
                initCorrectValidationRecords(or);
                dataImportService.getDuplicateResults().success(function (or) {
                    initDuplicateRecords(or);
                    triggBasicCheck();
                    $scope.setValidationErrorStyle(true, false);
                    $scope.setValidationErrorStyle(false, true);
                    if (isManage) {
                        SweetAlert.success($translate.instant('ManageDataSuccess'));
                    }                  
                });
            });
        });
    }


    //1.数据整理
    function startManageData(period) {      
        dataImportService.manageData(period).success(function (data) {
            getAllValidationResults(true);
        });
    }


    //根据erpCheckTypeId初始化不同的详细数据
    function getCheckDetails(erpCheckTypeId) {
        $scope.checkDetails = [];
        //试算平和表中的科目不在企业科目列表中
        if (erpCheckTypeId === ErpCheckTypeEnum.ComBalanceAcctUnValidate) {
            dataImportService.getAccountsNotInCompanyBalance()
              .success(function (data) {
                  $scope.checkDetails = initCheckDetailAcct(data);
              });
        }

        //Voucher中的科目不存在于科目表中
        if (erpCheckTypeId === ErpCheckTypeEnum.VoucherAcctValidate) {
            dataImportService.getAccountsNotInVoucherDetails()
              .success(function (data) {
                  $scope.checkDetails = initCheckDetailAcct(data);
              });
        }

        //单个凭证借贷平衡
        if (erpCheckTypeId === ErpCheckTypeEnum.VSingleDebitCreditUnValidate) {
            dataImportService.getSingleVoucherCheck()
              .success(function (data) {
                  $scope.checkDetails = initCheckDetailByVoucher(data);
              });
        }
           
        //Voucher ItemID 为空
        if (erpCheckTypeId === ErpCheckTypeEnum.VEmptyCheckUnValidateItemID) {
            dataImportService.getVoucherEmptyCheck(true, false, false, false, false)
              .success(function (data) {
                  $scope.checkDetails = initCheckDetailByVoucher(data);
              });
        }

        //Voucher Group 为空
        if (erpCheckTypeId === ErpCheckTypeEnum.VEmptyCheckUnValidateGroup) {
            dataImportService.getVoucherEmptyCheck(false, false, true, false, false)
              .success(function (data) {
                  $scope.checkDetails = initCheckDetailByVoucher(data);
              });
        }

        //Voucher AccontCode 为空
        if (erpCheckTypeId === ErpCheckTypeEnum.VEmptyCheckUnValidateAcctCode) {
            dataImportService.getVoucherEmptyCheck(false, false, false, true, false)
              .success(function (data) {
                  $scope.checkDetails = initCheckDetailByVoucher(data);
              });
        }

        //Voucher Summary 为空
        if (erpCheckTypeId === ErpCheckTypeEnum.VEmptyCheckUnValidateSummary) {
            dataImportService.getVoucherEmptyCheck(false,false,false,false,true)
              .success(function (data) {
                  $scope.checkDetails = initCheckDetailByVoucher(data);
            });
        }

        //试算平衡表中期初余额上下级不平衡
        if (erpCheckTypeId === ErpCheckTypeEnum.AcctBegBalAcctLevelUnValidate) {
            dataImportService.getAccountBegBalances(period)
              .success(function (data) {
                  $scope.checkDetails = initCheckDetailAcct(data);
              });
        }

        //试算平衡表中期初余额借贷不平衡
        if (erpCheckTypeId === ErpCheckTypeEnum.BegBalUnValidate) {
            dataImportService.getBegBalancesByPeriod(period)
              .success(function (data) {
                  //title
                  var detailTitleDto = [];
                  detailTitleDto.push($translate.instant('BegDebitBal'));
                  detailTitleDto.push($translate.instant('BegCreditBal'));
                  $scope.checkDetails.push(detailTitleDto);

                  //body
                  var detailDto = [];
                  if (detailTitleDto.indexOf($translate.instant('BegDebitBal')) !== -1) {
                      data.forEach(function (item, index) {
                          if (item.direction == "1") {
                              detailDto.push(item.begBal);
                          }
                      });                    
                  }

                  if (detailTitleDto.indexOf($translate.instant('BegCreditBal')) !== -1) {
                      data.forEach(function (item, index) {
                          if (item.direction == "-1") {
                              detailDto.push(item.begBal);
                          }
                      });
                  }                 
                  $scope.checkDetails.push(detailDto);
              });
        }

        //原始/计算期末余额比较 
        if (erpCheckTypeId === ErpCheckTypeEnum.CompCustEndBalUnValidate) {
            var isExistedEndBal = false;
            dataImportService.getCompCustBalanceDetail(period, period)
              .success(function (data) {
                  dataImportService.isComBalanceEndBalNotZero(period)
                    .success(function (enddata) {
                        isExistedEndBal = enddata;
                        $scope.checkDetails = initCheckDetailCompareEndBal(isExistedEndBal, data);
                    })
              });
        }

        //原始/计算发生额比较
        if (erpCheckTypeId === ErpCheckTypeEnum.CompCustAmountUnValidate) {
            dataImportService.compareCompCustPeriodAmount(period, period)
              .success(function (data) {
                  $scope.checkDetails = initCheckDetailCompareAmount(data);
              });
        }

        //上月期末与导入的本月期初
        if (erpCheckTypeId === ErpCheckTypeEnum.BegEndBalUnValidate) {
            var isExistedEndBal = false;
            dataImportService.compareCustEndCompBeg(period, period)
              .success(function (data) {
                  dataImportService.isComBalanceEndBalNotZero(period)
                    .success(function (endData) {
                        isExistedEndBal = endData;
                        $scope.checkDetails = initCheckDetailEndBalCompare(isExistedEndBal, data);                     
                    });
              });
        }


        //凭证重复
        if (erpCheckTypeId === ErpCheckTypeEnum.DuplicatedVoucher) {
            dataImportService.getDuplicateVouchers()
              .success(function (data) {              
                  $log.debug("set duplicated voucher details data");
                  $scope.gridUiDuplicateVouchers.data = data;
                  $log.debug($scope.gridUiDuplicateVouchers.data);
              });
        }

        //CustBalance重复
        if (erpCheckTypeId === ErpCheckTypeEnum.DuplicatedTb) {
            dataImportService.getCustBalanceDuplicateItems()
              .success(function (data) {
                  $log.debug("set duplicated custbalance details data");
                  $scope.gridUiDuplicateTbes.data = data;
                  $log.debug($scope.gridUiDuplicateTbes.data);
              });
        }
    }


    //初始化Voucher相关的详细信息
    function initCheckDetailByVoucher(data) {
        var detailTitleDto = [];
        var voucherDetails = [];
        //title       
        detailTitleDto.push($translate.instant('AccountCode'));
        detailTitleDto.push($translate.instant('JournalKHDM'));
        detailTitleDto.push($translate.instant('vid'));
        detailTitleDto.push($translate.instant('vGroup'));
        detailTitleDto.push($translate.instant('period'));
        detailTitleDto.push($translate.instant('itemID'));
        detailTitleDto.push($translate.instant('JournalZY'));
        detailTitleDto.push($translate.instant('JournalJFJE'));
        detailTitleDto.push($translate.instant('JournalDFJE'));
        
        voucherDetails.push(detailTitleDto);

        if (_.isNull(data)) {
            return false;
        }

        //body
        data.forEach(function(item,index){
            var detailDto = [];
            if (detailTitleDto.indexOf($translate.instant('AccountCode')) !== -1) {
                detailDto.push(item.acctCode);
            }

            if (detailTitleDto.indexOf($translate.instant('JournalKHDM')) !== -1) {
                detailDto.push(item.customerCode);
            }

            if (detailTitleDto.indexOf($translate.instant('vid')) !== -1) {
                detailDto.push(item.vid);
            }

            if (detailTitleDto.indexOf($translate.instant('vGroup')) !== -1) {
                detailDto.push(item.group);
            }

            if (detailTitleDto.indexOf($translate.instant('period')) !== -1) {
                detailDto.push(item.period);
            }

            if (detailTitleDto.indexOf($translate.instant('itemID')) !== -1) {
                detailDto.push(item.itemID);
            }

            if (detailTitleDto.indexOf($translate.instant('JournalZY')) !== -1) {
                detailDto.push(item.summary);
            }

            if (detailTitleDto.indexOf($translate.instant('JournalJFJE')) !== -1) {
                detailDto.push(item.debit);
            }

            if (detailTitleDto.indexOf($translate.instant('JournalDFJE')) !== -1) {
                detailDto.push(item.credit);
            }
                     
            voucherDetails.push(detailDto);
        });
       
        return voucherDetails;
    }


    //初始话科目相关的详细信息
    function initCheckDetailAcct(data)
    {
        //title
        var detailTitleDto = [];
        var acctDetails = [];
        detailTitleDto.push($translate.instant('AccountCode'));
        acctDetails.push(detailTitleDto);
        if (_.isNull(data)) {
            return false;
        }

        //body
        data.forEach(function (item, index) {
            var detailDto = [];
            if (detailTitleDto.indexOf($translate.instant('AccountCode')) !== -1) {
                detailDto.push(item.acctCode);
            }
            acctDetails.push(detailDto);
        });                 
       
        return acctDetails
    }


    //初始化上月期末与导入的本月期初校验的详细信息
    function initCheckDetailEndBalCompare(isEndBal, data) {
        var detailTitleDto = [];
        var compareDetails = [];

        //title
        detailTitleDto.push($translate.instant('PeriodId'));
        detailTitleDto.push($translate.instant('AccountCode'));
        detailTitleDto.push($translate.instant('AccountName'));
         
        if (isEndBal) {
            detailTitleDto.push($translate.instant('LastPeriodEndBal'));
            detailTitleDto.push($translate.instant('CurrentPeriodEndBal'));
            detailTitleDto.push($translate.instant('BalDiff'));
        }
        else {
            detailTitleDto.push($translate.instant('LastPeriodEndDebitBal'));
            detailTitleDto.push($translate.instant('LastPeriodEndCreditBal'));
            detailTitleDto.push($translate.instant('CurrentPeriodBegDebitBal'));
            detailTitleDto.push($translate.instant('CurrentPeriodBegCreditBal'));
            detailTitleDto.push($translate.instant('DebitBalDiff'));
            detailTitleDto.push($translate.instant('CreditBalDiff'));
        }
        compareDetails.push(detailTitleDto);
        
        if (_.isNull(data)) {
            return false;
        }

        //body
        data.forEach(function (item, index) {
            var detailDto = [];

            if (detailTitleDto.indexOf($translate.instant('PeriodId')) !== -1) {
                detailDto.push(item.periodId);
            }

            if (detailTitleDto.indexOf($translate.instant('AccountCode')) !== -1) {
                detailDto.push(item.accountCode);
            }

            if (detailTitleDto.indexOf($translate.instant('AccountName')) !== -1) {
                detailDto.push(item.accountName);
            }

            if (isEndBal) {
                if (detailTitleDto.indexOf($translate.instant('LastPeriodEndBal')) !== -1) {
                    detailDto.push(item.custEndBal);
                }

                if (detailTitleDto.indexOf($translate.instant('CurrentPeriodEndBal')) !== -1) {
                    detailDto.push(item.comBegBal);
                }

                if (detailTitleDto.indexOf($translate.instant('BalDiff')) !== -1) {
                    detailDto.push(item.begBalDiff);
                }

            }
            else {

                if (detailTitleDto.indexOf($translate.instant('LastPeriodEndDebitBal')) !== -1) {
                    detailDto.push(item.custEndDebitBal);
                }

                if (detailTitleDto.indexOf($translate.instant('LastPeriodEndCreditBal')) !== -1) {
                    detailDto.push(item.custEndCreditBal);
                }

                if (detailTitleDto.indexOf($translate.instant('CurrentPeriodBegDebitBal')) !== -1) {
                    detailDto.push(item.comBegDebitBal);
                }

                if (detailTitleDto.indexOf($translate.instant('CurrentPeriodBegCreditBal')) !== -1) {
                    detailDto.push(item.comBegCreditBal);
                }

                if (detailTitleDto.indexOf($translate.instant('DebitBalDiff')) !== -1) {
                    detailDto.push(item.begDebitDiff);
                }

                if (detailTitleDto.indexOf($translate.instant('CreditBalDiff')) !== -1) {
                    detailDto.push(item.begCreditDiff);
                }
            }
            compareDetails.push(detailDto);
        });
        
        return compareDetails;
    }


    //初始化原始/计算发生额的详细信息
    function initCheckDetailCompareAmount(data) {
        var detailTitleDto = [];
        var amountsDetails = [];

        //title
        detailTitleDto.push($translate.instant('PeriodId'));
        detailTitleDto.push($translate.instant('AccountCode'));
        detailTitleDto.push($translate.instant('AccountName'));
        detailTitleDto.push($translate.instant('ComDebitBal'));
        detailTitleDto.push($translate.instant('ComCreditBal'));
        detailTitleDto.push($translate.instant('CustDebitBal'));
        detailTitleDto.push($translate.instant('CustCreditBal'));
        detailTitleDto.push($translate.instant('DebitBalDiff'));
        detailTitleDto.push($translate.instant('CreditBalDiff'));
        amountsDetails.push(detailTitleDto);

        if (_.isNull(data)) {
            return false;
        }

        //body
        data.forEach(function (item, index) {
            var detailDto = [];

            if (detailTitleDto.indexOf($translate.instant('PeriodId')) !== -1) {
                detailDto.push(item.periodId);
            }

            if (detailTitleDto.indexOf($translate.instant('AccountCode')) !== -1) {
                detailDto.push(item.accountCode);
            }

            if (detailTitleDto.indexOf($translate.instant('AccountName')) !== -1) {
                detailDto.push(item.accountName);
            }

            if (detailTitleDto.indexOf($translate.instant('ComDebitBal')) !== -1) {
                detailDto.push(item.comDebitBal.toFixed(2));
            }

            if (detailTitleDto.indexOf($translate.instant('ComCreditBal')) !== -1) {
                detailDto.push(item.comCreditBal.toFixed(2));
            }

            if (detailTitleDto.indexOf($translate.instant('CustDebitBal')) !== -1) {
                detailDto.push(item.custDebitBal.toFixed(2));
            }

            if (detailTitleDto.indexOf($translate.instant('CustCreditBal')) !== -1) {
                detailDto.push(item.custCreditBal.toFixed(2));
            }

            if (detailTitleDto.indexOf($translate.instant('DebitBalDiff')) !== -1) {
                detailDto.push(item.debitBalDiff.toFixed(2));
            }

            if (detailTitleDto.indexOf($translate.instant('DebitBalDiff')) !== -1) {
                detailDto.push(item.creditBalDiff.toFixed(2));
            }

            amountsDetails.push(detailDto);
        });

        return amountsDetails;
    }


    //初始化原始/计算期末余额的详细信息
    function initCheckDetailCompareEndBal(isEndBal, data) {
        var detailTitleDto = [];
        var compareDetails = [];

        //title
        detailTitleDto.push($translate.instant('PeriodId'));
        detailTitleDto.push($translate.instant('AccountCode'));
        detailTitleDto.push($translate.instant('AccountName'));

        if (isEndBal) {
            detailTitleDto.push($translate.instant('ComEndBal'));
            detailTitleDto.push($translate.instant('CustEndBal'));
            detailTitleDto.push($translate.instant('BalDiff'));
        }
        else {
            detailTitleDto.push($translate.instant('ComDebitBal'));
            detailTitleDto.push($translate.instant('ComCreditBal'));
            detailTitleDto.push($translate.instant('CustDebitBal'));
            detailTitleDto.push($translate.instant('CustCreditBal'));
            detailTitleDto.push($translate.instant('DebitBalDiff'));
            detailTitleDto.push($translate.instant('CreditBalDiff'));
        }
        compareDetails.push(detailTitleDto);

        if (_.isNull(data)) {
            return false;
        }

        //body
        data.forEach(function (item, index) {
            var detailDto = [];

            if (detailTitleDto.indexOf($translate.instant('PeriodId')) !== -1) {
                detailDto.push(item.periodId);
            }

            if (detailTitleDto.indexOf($translate.instant('AccountCode')) !== -1) {
                detailDto.push(item.accountCode);
            }

            if (detailTitleDto.indexOf($translate.instant('AccountName')) !== -1) {
                detailDto.push(item.accountName);
            }

            if (isEndBal) {
                if (detailTitleDto.indexOf($translate.instant('ComEndBal')) !== -1) {
                    detailDto.push(item.comEndBal.toFixed(2));
                }

                if (detailTitleDto.indexOf($translate.instant('CustEndBal')) !== -1) {
                    detailDto.push(item.custEndBal.toFixed(2));
                }

                if (detailTitleDto.indexOf($translate.instant('BalDiff')) !== -1) {
                    detailDto.push(item.endDiff.toFixed(2));
                }

            }
            else {

                if (detailTitleDto.indexOf($translate.instant('ComDebitBal')) !== -1) {
                    detailDto.push(item.comEndDebitBal.toFixed(2));
                }

                if (detailTitleDto.indexOf($translate.instant('ComCreditBal')) !== -1) {
                    detailDto.push(item.comEndCreditBal.toFixed(2));
                }

                if (detailTitleDto.indexOf($translate.instant('CustDebitBal')) !== -1) {
                    detailDto.push(item.custEndDebitBal.toFixed(2));
                }

                if (detailTitleDto.indexOf($translate.instant('CustCreditBal')) !== -1) {
                    detailDto.push(item.custEndCreditBal.toFixed(2));
                }

                if (detailTitleDto.indexOf($translate.instant('DebitBalDiff')) !== -1) {
                    detailDto.push(item.debitBalDiff.toFixed(2));
                }

                if (detailTitleDto.indexOf($translate.instant('CreditBalDiff')) !== -1) {
                    detailDto.push(item.creditBalDiff.toFixed(2));
                }
            }
            compareDetails.push(detailDto);
        });

        return compareDetails;
    } 


    //初始化重复Voucher弹出框
    function initUiGvVoucherDupDetails() {
        $scope.gridUiDuplicateVouchers = {
            //set gridview options
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.rowHeight,
            enableSorting: false,
            enableColumnMenus: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            enableRowSelection: true,
            enableSelectAll: true,
            multiSelect: true,
            enableColumnResizing: true,
            columnDefs: [
                  {
                      name: $translate.instant('period'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.period}}<span></div>'
                  },
                  {
                      name: $translate.instant('vGroup'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.group}}<span></div>'
                  },
                  {
                      name: $translate.instant('vid'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.vid}}<span></div>'
                  },
                  {
                      name: $translate.instant('itemID'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.itemID}}</span></div>'
                  },
                  {
                      name: $translate.instant('AccountCode'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.acctCode}}<span></div>'
                  },
                  {
                      name: $translate.instant('JournalZY'), width: '30%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.summary}}<span></div>'
                  },
                  {
                      name: $translate.instant('DebitBal'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.debit}}<span></div>'
                  },
                  {
                      name: $translate.instant('CreditBal'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.credit}}<span></div>'
                  }                 
                  //{
                  //    name: $translate.instant('VoucherID'), width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.voucherID}}</span></div>'
                  //}
            ],
            onRegisterApi: function (gridApi) {
                $scope.gridApi = gridApi;

                // call resize every 500 ms for 5 s after modal finishes opening - usually only necessary on a bootstrap modal
                $interval(function () {
                    $scope.gridApi.core.handleWindowResize();
                }, 500, 60 * 60 * 8);

                gridApi.selection.on.rowSelectionChanged($scope, function (row) {
                    var msg = 'row selected ' + row.isSelected;
                    $log.debug(msg);
                });

                gridApi.selection.on.rowSelectionChangedBatch($scope, function (rows) {
                    var msg = 'rows changed ' + rows.length;
                    $log.debug(msg);
                });
            }
        };

        $scope.gridUiDuplicateVouchers.data = [];
    }
    

    //初始化重复Tb弹出框
    function initUiGvTbDupDetails() {
        $scope.gridUiDuplicateTbes = {
            //set gridview options
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.rowHeight,
            enableSorting: false,
            enableColumnMenus: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            enableRowSelection: true,
            enableSelectAll: true,
            multiSelect: true,
            columnDefs: [
                  {
                      name: $translate.instant('period'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.periodId}}<span></div>'
                  },
                  {
                      name: $translate.instant('AccountCode'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.acctCode}}<span></div>'
                  },
                  {
                      name: $translate.instant('JournalKHDM'), width: '15%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.customerCode}}<span></div>'
                  },
                  {
                      name: $translate.instant('BegDebitBal'), width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.begDebitBal}}<span></div>'
                  },
                  {
                      name: $translate.instant('BegCreditBal'), width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.begCreditBal}}<span></div>'
                  }, 
                  {
                      name: $translate.instant('BegBal'), width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.begBal}}<span></div>'
                  }
                               
            ],
            onRegisterApi: function (gridApi) {
                $scope.gridApiTb = gridApi;

                // call resize every 500 ms for 5 s after modal finishes opening - usually only necessary on a bootstrap modal
                $interval(function () {
                    $scope.gridApiTb.core.handleWindowResize();
                }, 500, 60 * 60 * 8);

                gridApi.selection.on.rowSelectionChanged($scope, function (row) {
                    //var msg = 'row selected ' + row.isSelected;
                    //$log.debug(msg);
                });

                gridApi.selection.on.rowSelectionChangedBatch($scope, function (rows) {
                    //var msg = 'rows changed ' + rows.length;
                    //$log.debug(msg);
                });
            }
        };

        $scope.gridUiDuplicateTbes.data = [];
    }


    //更新TaxAdmin中dbo.PeriodInfo.ImportType
    function updateProjectImportType() {
        var queryImportDto = {
            serviceTypeId: constant.serviceType.VAT,
            periods: [period],
            projectId: projectId,
            importTypeId: enums.TbImportTypeEnum.ErpImported
        }

        vatImportService.updatePeriodStatus(queryImportDto)
          .success(function (data) {
              $log.debug("vatImportService.updatePeriodStatus complete");
          });
    }


    //重新校验和整理数据
    function ReCheckAndManageData() {
        $log.debug("star to recheck and remanage data");         
        dataImportService.reManageData(period).success(function (data) {
            if (data) {
                $log.debug("remanage data successfully");
                getAllValidationResults(true);
            }
        });
    }


    function triggBasicCheck() {
        //默认选中基础校验
        setTimeout(function () {
            $('#btnBasicChk').trigger('click');
        }, 1000);
    }
    

    function getPeriodInfor() {
        vatImportService.getImportType(vatSessionService.project.id, period).success(function (data) {
            $scope.isImportTypeErp = enums.projectImportType.ErpImported === data ? true : false;                          
        });
    }

    //默认显示万能导入   
    $scope.switch(2);
    $scope.checkUserOrganizationPermissionList();
    getPeriodInfor();
    getAllValidationResults(false);
    initUiGvVoucherDupDetails();
    initUiGvTbDupDetails();


}]);